#include <stdio.h>
#include <stdlib.h>

#define BUFSIZE 16384

int unescape_sql(char *table, FILE *in, FILE *out ) {
	int c;
	int inside_quote = 0;

	while ( !feof( in ) ) {
		c = fgetc( in );
		if ( c == '\\' ) {
			c = fgetc( in );
			if ( c == '\'') {
				/* Escape single quote */
				fputs( "''", out);
			}
		} else {
			if ( c == '\'' ) {
				inside_quote = !inside_quote;
			}
			fputc( c, out );

			if ( c == ')' && !inside_quote ) {
				c = fgetc( in );
				if (  c == ';' ) {
					/* New INSERT TO ... */
					fputc( c, out );
				} else {
					if ( c != ',' ) {
						fprintf( stderr, "Unexpected character %c, expecting ,\n", c );
						return 1;
					}
					c = fgetc( in );
					if ( c != '(' ) {
						fprintf( stderr, "Unexpected character %c, expecting (\n", c );
						return 1;
					}
					fprintf( out, ";\nINSERT INTO `%s` VALUES (", table );
				}
			}
		}
	}

	fflush( out );

	return 0;

}

int main(int argc, char **argv ) {

	if ( unescape_sql(argv[1], stdin, stdout) != 0 ) {
		fprintf( stderr, "Error during escaping\n" );
		return EXIT_FAILURE;
	}

	return EXIT_SUCCESS;
}
